Forum:Lisp
Thema:Polylinie mit Objektdaten in 3DPolylinie umwandeln
Möchten Sie sich registrieren?
Wer darf antworten? Registrierte Benutzer können Beiträge verfassen.
Hinweise zur Registrierung Sie müssen registriert sein, um Beiträge oder Antworten auf Beiträge schreiben zu können.
Ihr Benutzername:
Ihr Kennwort:   Kennwort vergessen?
Anhang:    Datei(en) anhängen  <?>   Anhänge verwalten  <?>
Grafik für den Beitrag:                                                
                                                       
Ihre Antwort:

Fachbegriff
URL
Email
Fett
Kursiv
Durchgestr.
Liste
*
Bild
Zitat
Code

*HTML ist AUS
*UBB-Code ist AN
Smilies Legende
Netiquette

10 20 40

Optionen Smilies in diesem Beitrag deaktivieren.
Signatur anfügen: die Sie bei den Voreinstellungen angegeben haben.

Wenn Sie bereits registriert sind, aber Ihr Kennwort vergessen haben, klicken Sie bitte hier.

Bitte drücken Sie nicht mehrfach auf "Antwort speichern".

*Ist HTML- und/oder UBB-Code aktiviert, dann können Sie HTML und/oder UBB Code in Ihrem Beitrag verwenden.

T H E M A     A N S E H E N
Andreas Kraus

Beiträge: 1120 / 1

WIN 10
ACAD 2017

Hm, komisch.
Ich stells hier nochmal komplett rein. Bei mir funktionierts.
Den Namen der Funktion kannst du ja ändern wie du willst.

[CODE][
(defun c  oly->3d-poly (/ DUMMY INS_LIST P PLINEOBJ POINTS P_LIST)
  (defun k_ac-doc ()
    (vla-get-activedocument (vlax-get-acad-object))
  )

  (defun k_3d->2d (wert / dummy)
    (if (vl-every '(lambda (dummy) (= (type dummy) 'LIST)) wert)
      (mapcar '(lambda (dummy) (list (car dummy) (cadr dummy)))
      wert
      )
      (list (car wert) (cadr wert))
    )
  )

  (defun k_->obj_name (name)
;;; VLA-OBJECT zurückgeben
    (cond
      ((= (type name) 'ENAME)
       (vlax-ename->vla-object name)
      )
      ((= (type name) 'VLA-OBJECT)
       name
      )
      ((= (type name) 'STRING)
       (vlax-ename->vla-object (handent name))
      )
      ((= (type name) 'LIST)
       (vlax-ename->vla-object (cdr (assoc -1 name)))
      )
    )
  )

  (defun k_satz->entlist (satz)
;;; Elementliste aus Auswahlsatz erstellen
    (if (= (type satz) 'PICKSET)
      (vl-remove-if-not
'(lambda (dummy) (= (type dummy) 'ENAME))
(mapcar 'cadr (ssnamex satz))
      )
    )
  )

  (defun k_get_att (ins name)
;;; Attributinhalt zurückgeben
    (setq ins (k_->obj_name ins))
    (if (and (vlax-property-available-p ins "hasattributes")
     (= (vla-get-hasattributes ins) :vlax-true)
     (not (minusp (vlax-safearray-get-u-bound
    (vlax-variant-value
      (vla-getattributes ins)
    )
    1
  )
  )
     )
)
      (vla-get-textstring
(car (vl-remove-if-not
       '(lambda (att) (= (vla-get-tagstring att) name))
       (vlax-invoke ins 'GetAttributes)
     )
)
      )
    )
  )

  (vl-load-com)
  (setq ins_list
(mapcar
   'entget
   (k_satz->entlist (ssget "x" '((0 . "INSERT") (2 . "VM"))))
)
  )

  (foreach ent_data
   (mapcar 'entget
   (k_satz->entlist (ssget '((0 . "LWPOLYLINE"))))
   )
    (setq p_list
   (mapcar
     '(lambda (p)
(append
  p
  (list
    (atof
      (k_get_att
(cdr
  (assoc
    -1
    (car
      (vl-remove-if-not
'(lambda (ins)
   (equal p
  (k_3d->2d (cdr (assoc 10 ins)))
  0.01
   )
)
ins_list
      )
    )
  )
)
"HOEHE"
      )
    )
  )
)
      )
     (mapcar 'cdr
     (vl-remove-if-not
       '(lambda (data) (= (car data) 10))
       ent_data
     )
     )
   )
    )

    (setq points (vlax-make-safearray
   vlax-vbDouble
   (cons 0 (1- (* (length p_list) 3)))
)
    )
    (vlax-safearray-fill
      points
      (apply 'append p_list)
    )
    (setq plineObj
   (vla-Add3DPoly
     (vla-get-block (vla-get-activelayout (k_ac-doc)))
     points
   )
    )
  )
  (princ)
)
/CODE]

Edit:
Hab grade gesehen dass in der Zeile wo der Programmcode zuende ist noch die letzte Klammer steht. Vielleicht hast du die nicht mitkopiert.
Ich habs hier mal geändert.

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

[Diese Nachricht wurde von Andreas Kraus am 16. Mai. 2019 editiert.]